// EditCommandDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MX_CECUtil.h"
#include "EditCommandDlg.h"


// CEditCommandDlg dialog

IMPLEMENT_DYNAMIC(CEditCommandDlg, CDialog)

CEditCommandDlg::CEditCommandDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditCommandDlg::IDD, pParent)
{
	m_iEditPage = 1;
	m_bSaveData = FALSE;
}

CEditCommandDlg::~CEditCommandDlg()
{
}

void CEditCommandDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON_CMDSET_PREV, m_PrevBtnCtrl);
	DDX_Control(pDX, IDC_BUTTON_CMDSET_NEXT, m_NextBtnCtrl);
}


BEGIN_MESSAGE_MAP(CEditCommandDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_CMDSET_PREV, &CEditCommandDlg::OnBnClickedButtonCmdsetPrev)
	ON_BN_CLICKED(IDC_BUTTON_CMDSET_NEXT, &CEditCommandDlg::OnBnClickedButtonCmdsetNext)
	ON_BN_CLICKED(IDOK, &CEditCommandDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CEditCommandDlg message handlers
BOOL CEditCommandDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ShowPage(m_iEditPage);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEditCommandDlg::OnBnClickedButtonCmdsetPrev()
{
	if (SaveChanges())
	{
		m_iEditPage --;
		ShowPage(m_iEditPage);
	}
}

void CEditCommandDlg::OnBnClickedButtonCmdsetNext()
{
	if (SaveChanges())
	{
		m_iEditPage ++;
		ShowPage(m_iEditPage);
	}
}

void CEditCommandDlg::ShowPage(int iPage)
{
	if (m_iEditPage <= MIN_PAGE)
		m_iEditPage = MIN_PAGE;
	if (m_iEditPage >= MAX_PAGE)
		m_iEditPage = MAX_PAGE;
	m_PrevBtnCtrl.EnableWindow(m_iEditPage > MIN_PAGE);
	m_NextBtnCtrl.EnableWindow(m_iEditPage < MAX_PAGE);

	CString strTemp, strItem1;
	for (int i = 0; i < PAGE_MULT; i ++)
	{
		int iCmdNum = i + ((m_iEditPage - 1) * PAGE_MULT) + 1;
		strTemp.LoadString(IDS_STR_DEF_CMD_NAME);
		strItem1.Format(strTemp,iCmdNum);
		SetDlgItemText(IDC_STATIC_COMMAND_1 + i,strItem1);

		strTemp.Empty();
		strItem1.Empty();
		for (int j = 0; j < m_EditData.cmd[iCmdNum - 1].iNumData; j ++)
		{
			strTemp.Format(L"%.2x ",m_EditData.cmd[iCmdNum - 1].iData[j]);
			strItem1 += strTemp;
		}
		SetDlgItemText(IDC_EDIT_COMMAND_1 + i,strItem1);
		SetDlgItemText(IDC_EDIT_COMMANDNAME_1 + i, m_EditData.cmd[iCmdNum - 1].wszCaptionName);
		CheckDlgButton(IDC_CHECK_CMD_BCAST_1 + i, m_EditData.cmd[iCmdNum - 1].bBroadcast);
	}
}

BOOL CEditCommandDlg::SaveChanges()
{
	int i;
	BOOL bError = FALSE;
	CString strTemp, strTitle, strErrMsg;
	//Do a sanity check first before saving
	for (i = 0; i < PAGE_MULT; i ++)
	{
		int iCmdNum = i + ((m_iEditPage - 1) * PAGE_MULT) + 1;
		wchar_t wszItem[256];
		ZeroMemory(wszItem,sizeof(wchar_t)*256);
		GetDlgItemText(IDC_EDIT_COMMAND_1 + i,wszItem,256);
		int iCmdCount = 0;
		wchar_t *pwszToken = wcstok(wszItem,L" ");

		while (pwszToken)
		{
			wchar_t *pwszStopScan = NULL;
			iCmdCount ++;
			int iData = wcstoul(pwszToken,&pwszStopScan,16);
			if (*pwszStopScan)
			{
				strTemp.LoadString(IDS_STR_ERR_DATA_INVALID_ILLEGAL);
				strErrMsg.Format(strTemp,iCmdNum);
				bError = TRUE;
				break;
			}
			if (iData > 0xff)
			{
				strTemp.LoadString(IDS_STR_ERR_DATA_INVALID_TOO_BIG);
				strErrMsg.Format(strTemp,iCmdNum);
				bError = TRUE;
				break;
			}
			pwszToken = wcstok(NULL,L" ");
		}
		if (bError)
			break;

		if (iCmdCount > MAX_NUM_CEC_DATA)
		{
			strTemp.LoadString(IDS_STR_ERR_DATA_INVALID_TOO_MANY);
			strErrMsg.Format(strTemp,iCmdNum);
			bError = TRUE;
			break;
		}
		ZeroMemory(wszItem,sizeof(wchar_t)*256);
		GetDlgItemText(IDC_EDIT_COMMANDNAME_1 + i,wszItem,256);
		if (wcslen(wszItem) > 12)
		{
			strTemp.LoadString(IDS_STR_ERR_NAME_TOO_LONG);
			strErrMsg.Format(strTemp,iCmdNum);
			bError = TRUE;
			break;
		}
	}

	if (bError)
	{
		strTitle.LoadString(IDS_STR_ERR_TITLE);
		MessageBox(strErrMsg,strTitle,MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	for (i = 0; i < PAGE_MULT; i ++)
	{
		int iCmdNum = i + ((m_iEditPage - 1) * PAGE_MULT) + 1;
		wchar_t wszItem[256];
		ZeroMemory(wszItem,sizeof(wchar_t)*256);
		GetDlgItemText(IDC_EDIT_COMMAND_1 + i,wszItem,256);
		int iCmdCount = 0;
		wchar_t *pwszToken = wcstok(wszItem,L" ");

		while (pwszToken)
		{
			m_EditData.cmd[iCmdNum - 1].iData[iCmdCount] = wcstoul(pwszToken,NULL,16);
			iCmdCount ++;
			pwszToken = wcstok(NULL,L" ");
		}
		m_EditData.cmd[iCmdNum - 1].iNumData = iCmdCount;

		ZeroMemory(wszItem,sizeof(wchar_t)*256);
		GetDlgItemText(IDC_EDIT_COMMANDNAME_1 + i,wszItem,256);
		ZeroMemory(m_EditData.cmd[iCmdNum - 1].wszCaptionName,sizeof(wchar_t)*80);
		wcsncpy(m_EditData.cmd[iCmdNum - 1].wszCaptionName,wszItem,79);
		m_EditData.cmd[iCmdNum - 1].bBroadcast = IsDlgButtonChecked(IDC_CHECK_CMD_BCAST_1 + i);
	}

	return TRUE;
}

void CEditCommandDlg::ReadCECData(CEC_DATA* pCECData)
{
	if (!pCECData)
		return;

	memcpy(&m_EditData,pCECData,sizeof(CEC_DATA));
}

void CEditCommandDlg::CopyCECData(CEC_DATA* pCECData)
{
	if (!pCECData)
		return;

	memcpy(pCECData,&m_EditData,sizeof(CEC_DATA));
}

void CEditCommandDlg::OnBnClickedOk()
{
	if (SaveChanges())
	{
		m_bSaveData = TRUE;
		OnOK();
	}
}
