`
// MX_CECUtilDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MX_CECUtil.h"
#include "MX_CECUtilDlg.h"
#include "WaitDiscoverDevDlg.h"
#include "EditCommandDlg.h"
#include "CECMgr.h"

CCECMgr				g_CECMgr;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMX_CECUtilDlg dialog




CMX_CECUtilDlg::CMX_CECUtilDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMX_CECUtilDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bInitialized = FALSE;
	m_iCurrSelDevIndex = 0;
	m_bDiscoverDevice = FALSE;
	m_iNumDiscoveredDevLogicalAddr = 0;
}

void CMX_CECUtilDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_LOG, m_LogListBoxCtrl);
	DDX_Control(pDX, IDC_COMBO_CURR_DEV, m_DeviceCmbCtrl);
}

BEGIN_MESSAGE_MAP(CMX_CECUtilDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_DISCOVER_DEV, &CMX_CECUtilDlg::OnBnClickedButtonDiscoverDev)
	ON_BN_CLICKED(IDC_BUTTON_CMD_1, &CMX_CECUtilDlg::OnBnClickedButtonCmd1)
	ON_BN_CLICKED(IDC_BUTTON_CMD_2, &CMX_CECUtilDlg::OnBnClickedButtonCmd2)
	ON_BN_CLICKED(IDC_BUTTON_CMD_3, &CMX_CECUtilDlg::OnBnClickedButtonCmd3)
	ON_BN_CLICKED(IDC_BUTTON_CMD_4, &CMX_CECUtilDlg::OnBnClickedButtonCmd4)
	ON_BN_CLICKED(IDC_BUTTON_CMD_5, &CMX_CECUtilDlg::OnBnClickedButtonCmd5)
	ON_BN_CLICKED(IDC_BUTTON_CMD_6, &CMX_CECUtilDlg::OnBnClickedButtonCmd6)
	ON_BN_CLICKED(IDC_BUTTON_CMD_7, &CMX_CECUtilDlg::OnBnClickedButtonCmd7)
	ON_BN_CLICKED(IDC_BUTTON_CMD_8, &CMX_CECUtilDlg::OnBnClickedButtonCmd8)
	ON_BN_CLICKED(IDC_BUTTON_CMD_9, &CMX_CECUtilDlg::OnBnClickedButtonCmd9)
	ON_BN_CLICKED(IDC_BUTTON_CMD_10, &CMX_CECUtilDlg::OnBnClickedButtonCmd10)
	ON_BN_CLICKED(IDC_BUTTON_CMD_11, &CMX_CECUtilDlg::OnBnClickedButtonCmd11)
	ON_BN_CLICKED(IDC_BUTTON_CMD_12, &CMX_CECUtilDlg::OnBnClickedButtonCmd12)
	ON_BN_CLICKED(IDC_BUTTON_CMD_13, &CMX_CECUtilDlg::OnBnClickedButtonCmd13)
	ON_BN_CLICKED(IDC_BUTTON_CMD_14, &CMX_CECUtilDlg::OnBnClickedButtonCmd14)
	ON_BN_CLICKED(IDC_BUTTON_CMD_15, &CMX_CECUtilDlg::OnBnClickedButtonCmd15)
	ON_BN_CLICKED(IDC_BUTTON_CMD_16, &CMX_CECUtilDlg::OnBnClickedButtonCmd16)
	ON_BN_CLICKED(IDC_BUTTON_CMD_17, &CMX_CECUtilDlg::OnBnClickedButtonCmd17)
	ON_BN_CLICKED(IDC_BUTTON_CMD_18, &CMX_CECUtilDlg::OnBnClickedButtonCmd18)
	ON_BN_CLICKED(IDC_BUTTON_CMD_19, &CMX_CECUtilDlg::OnBnClickedButtonCmd19)
	ON_BN_CLICKED(IDC_BUTTON_CMD_20, &CMX_CECUtilDlg::OnBnClickedButtonCmd20)
	ON_BN_CLICKED(IDC_BUTTON_CMD_21, &CMX_CECUtilDlg::OnBnClickedButtonCmd21)
	ON_BN_CLICKED(IDC_BUTTON_CMD_22, &CMX_CECUtilDlg::OnBnClickedButtonCmd22)
	ON_BN_CLICKED(IDC_BUTTON_CMD_23, &CMX_CECUtilDlg::OnBnClickedButtonCmd23)
	ON_BN_CLICKED(IDC_BUTTON_CMD_24, &CMX_CECUtilDlg::OnBnClickedButtonCmd24)
	ON_BN_CLICKED(IDC_BUTTON_CMD_EDIT, &CMX_CECUtilDlg::OnBnClickedButtonCmdEdit)
	ON_MESSAGE(CEC_MESSAGE_DATA_START,OnCECStartMessage)
	ON_MESSAGE(CEC_MESSAGE_HAS_DATA,OnCECDataMessage)
	ON_MESSAGE(CEC_MESSAGE_DATA_END,OnCECEndMessage)
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_COMBO_CURR_DEV, &CMX_CECUtilDlg::OnCbnSelchangeComboCurrDev)
	ON_BN_CLICKED(IDC_BUTTON_LOG_CLEAR, &CMX_CECUtilDlg::OnBnClickedButtonLogClear)
END_MESSAGE_MAP()


// CMX_CECUtilDlg message handlers

BOOL CMX_CECUtilDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_bInitialized = g_CECMgr.Init();
	if (m_bInitialized)
	{
		m_pPollMgr = new CPollEventMgr((CWnd*)this);
		m_pPollMgr->StartEventThread();
		m_pPollMgr->AcceptEvent(new CMsgEvent(START_EVENT_POLL));

		ResetDiscoveredDevice();

		ReadCECData();
		RefreshControl();
	}
	else
	{
		CString strMsg, strTitle;

		strMsg.LoadString(IDS_STR_ERR_DEV_NOT_FOUND);
		strTitle.LoadStringW(IDS_STR_ERR_TITLE);
		MessageBox(strMsg,strTitle,MB_OK|MB_ICONEXCLAMATION);
	}
	CheckDlgButton(IDC_CHECK_AUTOSCROLL, TRUE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMX_CECUtilDlg::RefreshControl()
{
	for (int i = 0; i < MAX_NUM_CMD; i ++)
	{
		if (m_CECData.cmd[i].bBroadcast)
		{
			CString szItem;
			szItem.Format(L"*%s",m_CECData.cmd[i].wszCaptionName);
			SetDlgItemText(IDC_BUTTON_CMD_1+i,szItem.GetBuffer(0));
		}
		else
			SetDlgItemText(IDC_BUTTON_CMD_1+i,m_CECData.cmd[i].wszCaptionName);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMX_CECUtilDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

LRESULT CMX_CECUtilDlg::OnCECStartMessage(WPARAM wParam, LPARAM lParam)
{
	m_iNumRcvCECData = 0;
	ZeroMemory(m_iRcvCECData,sizeof(m_iRcvCECData));

	return 0L;
}

LRESULT CMX_CECUtilDlg::OnCECDataMessage(WPARAM wParam, LPARAM lParam)
{
	if (m_iNumRcvCECData < MAX_NUM_CEC_DATA)
	{
		m_iRcvCECData[m_iNumRcvCECData] = (BYTE)wParam;
		m_iNumRcvCECData ++;
	}

	return 0L;
}

LRESULT CMX_CECUtilDlg::OnCECEndMessage(WPARAM wParam, LPARAM lParam)
{
	CString szTemp, szMsg;
	szMsg = L"<< ";

	if (m_bDiscoverDevice)
	{
		BYTE iFoundDev = (m_iRcvCECData[0]&0xf0) >> 4;
		GetLogicalDevName(iFoundDev, &szTemp);
		szMsg += "Found Device: ";
		szMsg += szTemp;
		InsertLog(szMsg);
		m_iDiscoveredDevLogicalAddr[m_iNumDiscoveredDevLogicalAddr] = iFoundDev;
		m_iNumDiscoveredDevLogicalAddr ++;
	}
	else
	{
		for (int i = 0; i < m_iNumRcvCECData; i ++)
		{
			szTemp.Format(L"%.2x ",m_iRcvCECData[i]);
			szMsg += szTemp;
		}
		InsertLog(szMsg);
	}	
	return 0L;
}

void CMX_CECUtilDlg::InsertLog(CString szMsg)
{
	m_LogListBoxCtrl.AddString(szMsg);
	if (IsDlgButtonChecked(IDC_CHECK_AUTOSCROLL))
		m_LogListBoxCtrl.SetCurSel(m_LogListBoxCtrl.GetCount() - 1);
}

void CMX_CECUtilDlg::GetLogicalDevName(int iDevAddr, CString *pStrName)
{
	if (!pStrName)
		return;

	switch(iDevAddr)
	{
		case LOGIC_DEV_0_TV:
			*pStrName = L"TV";
		break;

		case LOGIC_DEV_1_DVR1:
			*pStrName = L"DVR1";
		break;

		case LOGIC_DEV_2_DVR2:
			*pStrName = L"DVR2";
		break;

		case LOGIC_DEV_3_TUNER1:
			*pStrName = L"TUNER1";
		break;

		case LOGIC_DEV_4_PLYR1:
			*pStrName = L"PLYR1";
		break;

		case LOGIC_DEV_5_AUDIO:
			*pStrName = L"AUDIO";
		break;

		case LOGIC_DEV_6_TUNER2:	
			*pStrName = L"TUNER2";
		break;

		case LOGIC_DEV_7_TUNER3:	
			*pStrName = L"TUNER3";
		break;

			case LOGIC_DEV_8_PLYR2:
			*pStrName = L"PLYR2";
		break;

		case LOGIC_DEV_9_DVR3:
			*pStrName = L"DVR3";
		break;

		case LOGIC_DEV_A_TUNER4:
			*pStrName = L"TUNER4";
		break;

		case LOGIC_DEV_B_PLYR3:
			*pStrName = L"PLYR3";
		break;

		case LOGIC_DEV_C_RSVP:
			*pStrName = L"RSVP1";
		break;

		case LOGIC_DEV_D_RSVP:
			*pStrName = L"RSVP2";
		break;

		case LOGIC_DEV_E_FREE:
			*pStrName = L"FREE";
		break;

		case LOGIC_DEV_F_BCAST:
			*pStrName = L"BCAST";
		break;
	}
}

void CMX_CECUtilDlg::ResetDiscoveredDevice()
{
	CString szTemp, szMsg;

	m_DeviceCmbCtrl.ResetContent();
	for (int i = 0; i < m_iNumDiscoveredDevLogicalAddr; i ++)
	{
		GetLogicalDevName(m_iDiscoveredDevLogicalAddr[i],&szTemp);
		szMsg.Format(L"%d:%s",m_iDiscoveredDevLogicalAddr[i],szTemp);
		m_DeviceCmbCtrl.AddString(szMsg);
	}

	if (m_iNumDiscoveredDevLogicalAddr > 0)
	{
		m_DeviceCmbCtrl.SetCurSel(0);
		m_iCurrSelDevIndex = 0;
	}
}

void CMX_CECUtilDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == TIMER_DISCOVER_DEVICE)
	{
		CString szTemp, szMsg;
		szMsg = L">> ";

		szMsg += L"Discovering device ";
		GetLogicalDevName(m_iCurrDiscoverDevCounter,&szTemp);
		szMsg += szTemp;
		szMsg += L"...";
		InsertLog(szMsg);

		g_CECMgr.SetDiscoverDevice(m_iCurrDiscoverDevCounter);
		if (m_iCurrDiscoverDevCounter >= NUM_LOGICAL_DEV - 1)
		{
			KillTimer(TIMER_DISCOVER_DEVICE);
			m_bDiscoverDevice = FALSE;
			//Reset the current device combo box
			ResetDiscoveredDevice();
			//Add one last time to signal the wait discover dialog box to close itself
			m_iCurrDiscoverDevCounter ++;
		}
		else
			m_iCurrDiscoverDevCounter ++;
	}

	CDialog::OnTimer(nIDEvent);
}


// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMX_CECUtilDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMX_CECUtilDlg::ReadCECData()
{
	wchar_t wszAppPath[MAX_PATH];
	wchar_t wszAppDrive[_MAX_DRIVE];
	wchar_t wszAppDir[_MAX_DIR];
	wchar_t wszIniPath[MAX_PATH];
	GetModuleFileName(NULL,wszAppPath,MAX_PATH);
	_wsplitpath(wszAppPath,wszAppDrive,wszAppDir,NULL,NULL);
	wsprintf(wszIniPath,L"%s%s%s",wszAppDrive,wszAppDir,CEC_DATA_FILE);

	WIN32_FIND_DATA wfd;
	HANDLE hFind = FindFirstFile(wszIniPath,&wfd);
	CString strTemp, strItem1,strItem2;
	strTemp.LoadStringW(IDS_STR_DEF_CMD_NAME);
	if (hFind == INVALID_HANDLE_VALUE)
	{
		for (int i = 0; i < MAX_NUM_CMD; i ++)
		{
			strItem1.Format(strTemp,i + 1);
			ZeroMemory(m_CECData.cmd[i].wszCaptionName,sizeof(wchar_t) * 80);
			wcsncpy(m_CECData.cmd[i].wszCaptionName,strItem1.GetBuffer(0),strItem1.GetLength());
		}

		for (int i = 0; i < MAX_NUM_CMD; i ++)
		{
			strItem1.Format(INI_SEC_CMD, i + 1);
			WritePrivateProfileString(strItem1, INI_CMD_NAME, m_CECData.cmd[i].wszCaptionName, wszIniPath);
			WritePrivateProfileString(strItem1, INI_CMD_BCAST, L"0", wszIniPath);
			WritePrivateProfileString(strItem1, INI_CMD_NUMDATA, L"0", wszIniPath);
			for (int j = 0; j < MAX_NUM_CEC_DATA; j ++)
			{
				strItem2.Format(INI_CMD_VAL, j + 1);
				WritePrivateProfileString(strItem1, strItem2, L"0", wszIniPath);
			}
		}
	}
	else
		FindClose(hFind);

	//Read data
	wchar_t wszReadString[80];
	wchar_t wszReadData[4];
	for (int i = 0; i < MAX_NUM_CMD; i ++)
	{
		strItem1.Format(INI_SEC_CMD, i + 1);
		ZeroMemory(wszReadString,sizeof(wszReadString));
		GetPrivateProfileString(strItem1, INI_CMD_NAME, L" ", wszReadString, 80, wszIniPath);
		ZeroMemory(m_CECData.cmd[i].wszCaptionName,sizeof(wchar_t) * 80);
		wcsncpy(m_CECData.cmd[i].wszCaptionName,wszReadString,wcslen(wszReadString));
		ZeroMemory(wszReadData,sizeof(wszReadData));
		GetPrivateProfileString(strItem1, INI_CMD_BCAST, L"0", wszReadData, 4, wszIniPath);
		m_CECData.cmd[i].bBroadcast = (BOOL)_wtoi(wszReadData);
		ZeroMemory(wszReadData,sizeof(wszReadData));
		GetPrivateProfileString(strItem1, INI_CMD_NUMDATA, L"0", wszReadData, 4, wszIniPath);
		m_CECData.cmd[i].iNumData = (BOOL)_wtoi(wszReadData);
		for (int j = 0; j < MAX_NUM_CEC_DATA; j ++)
		{
			strItem2.Format(INI_CMD_VAL, j + 1);
			ZeroMemory(wszReadData,sizeof(wszReadData));
			GetPrivateProfileString(strItem1, strItem2, L"0", wszReadData, 4, wszIniPath);
			m_CECData.cmd[i].iData[j] = (BYTE)wcstoul(wszReadData,NULL,16);
		}
	}
}

void CMX_CECUtilDlg::SaveCECData()
{
	wchar_t wszAppPath[MAX_PATH];
	wchar_t wszAppDrive[_MAX_DRIVE];
	wchar_t wszAppDir[_MAX_DIR];
	wchar_t wszIniPath[MAX_PATH];
	GetModuleFileName(NULL,wszAppPath,MAX_PATH);
	_wsplitpath(wszAppPath,wszAppDrive,wszAppDir,NULL,NULL);
	wsprintf(wszIniPath,L"%s%s%s",wszAppDrive,wszAppDir,CEC_DATA_FILE);

	CString strItem1,strItem2,strItem3;

	for (int i = 0; i < MAX_NUM_CMD; i ++)
	{
		strItem1.Format(INI_SEC_CMD, i + 1);
		WritePrivateProfileString(strItem1, INI_CMD_NAME, m_CECData.cmd[i].wszCaptionName, wszIniPath);
		strItem2.Format(L"%d", m_CECData.cmd[i].bBroadcast);
		WritePrivateProfileString(strItem1, INI_CMD_BCAST,strItem2.GetBuffer(0), wszIniPath);
		strItem2.Format(L"%d", m_CECData.cmd[i].iNumData);
		WritePrivateProfileString(strItem1, INI_CMD_NUMDATA, strItem2.GetBuffer(0), wszIniPath);
		for (int j = 0; j < MAX_NUM_CEC_DATA; j ++)
		{
			strItem2.Format(INI_CMD_VAL, j + 1);
			strItem3.Format(L"%x", m_CECData.cmd[i].iData[j]);
			WritePrivateProfileString(strItem1, strItem2, strItem3.GetBuffer(0), wszIniPath);
		}
	}
}

void CMX_CECUtilDlg::OnCbnSelchangeComboCurrDev()
{
	// TODO: Add your control notification handler code here
}

void CMX_CECUtilDlg::OnBnClickedButtonDiscoverDev()
{
	if (!m_bInitialized)
		return;

	ZeroMemory(m_iDiscoveredDevLogicalAddr,sizeof(m_iDiscoveredDevLogicalAddr));
	m_iNumDiscoveredDevLogicalAddr = 0;
	m_iCurrDiscoverDevCounter = 1;
	m_bDiscoverDevice = TRUE;
	SetTimer(TIMER_DISCOVER_DEVICE,TIMER_DISCOVER_DURATION,NULL);

	CWaitDiscoverDevDlg dlg(this);

	dlg.DoModal();

	if(m_bDiscoverDevice)
	{
		KillTimer(TIMER_DISCOVER_DEVICE);
		m_bDiscoverDevice = FALSE;
		ResetDiscoveredDevice();
	}
}

void CMX_CECUtilDlg::SendCECData(int iWhichCmd)
{
	if (!m_bInitialized)
		return;

	if (!m_CECData.cmd[iWhichCmd].iNumData)
		return;

	CString szTemp, szMsg;

	if (!m_CECData.cmd[iWhichCmd].bBroadcast)
	{
		if (!m_iNumDiscoveredDevLogicalAddr)
		{
			szMsg.LoadString(IDS_STR_NO_DEVICE);
			InsertLog(szMsg);
			return;
		}
	}
	int i;
	BYTE iTargetDev;
	if (m_CECData.cmd[iWhichCmd].bBroadcast)
		iTargetDev = 0xf;
	else
		iTargetDev = m_iDiscoveredDevLogicalAddr[m_iCurrSelDevIndex];

	g_CECMgr.WriteData(iTargetDev,m_CECData.cmd[iWhichCmd].iData,m_CECData.cmd[iWhichCmd].iNumData);

	szMsg = L">> ";
	szMsg += m_CECData.cmd[iWhichCmd].wszCaptionName;
	szMsg += L" - ";
	for (i = 0; i < m_CECData.cmd[iWhichCmd].iNumData; i ++)
	{
		szTemp.Format(L"%.2x ",m_CECData.cmd[iWhichCmd].iData[i]);
		szMsg += szTemp;
	}
	if (m_CECData.cmd[iWhichCmd].bBroadcast)
		szMsg += L"(Broadcast)";
	InsertLog(szMsg);

}

void CMX_CECUtilDlg::OnBnClickedButtonCmd1()
{
	SendCECData(0);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd2()
{
	SendCECData(1);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd3()
{
	SendCECData(2);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd4()
{
	SendCECData(3);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd5()
{
	SendCECData(4);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd6()
{
	SendCECData(5);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd7()
{
	SendCECData(6);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd8()
{
	SendCECData(7);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd9()
{
	SendCECData(8);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd10()
{
	SendCECData(9);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd11()
{
	SendCECData(10);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd12()
{
	SendCECData(11);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd13()
{
	SendCECData(12);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd14()
{
	SendCECData(13);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd15()
{
	SendCECData(14);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd16()
{
	SendCECData(15);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd17()
{
	SendCECData(16);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd18()
{
	SendCECData(17);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd19()
{
	SendCECData(18);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd20()
{
	SendCECData(19);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd21()
{
	SendCECData(20);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd22()
{
	SendCECData(21);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd23()
{
	SendCECData(22);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmd24()
{
	SendCECData(23);
}

void CMX_CECUtilDlg::OnBnClickedButtonCmdEdit()
{
	CEditCommandDlg dlg;

	dlg.ReadCECData(&m_CECData);

	dlg.DoModal();
	if (dlg.IsSavingNeeded())
	{
		dlg.CopyCECData(&m_CECData);
		RefreshControl();
		SaveCECData();
	}
}

CPollEventMgr::CPollEventMgr(CWnd* pParent)
{
	m_pPollParent = pParent;
	m_iPollInterval = 500;
}

INT_32 CPollEventMgr::ServiceEvent(CMsgEvent *pEvent)
{
	if (!pEvent)
		return 255;

	switch (pEvent->Type())
	{
		case START_EVENT_POLL:
		{
			do
			{
				DWORD dwStartTime = GetTickCount();

				if (m_pEventThreadQueue->Peek())	// if there's something in the service queue
				{
					// we will send a new event to return to this command again
					AcceptEvent(new CMsgEvent(START_EVENT_POLL));
					break;
				}
				
				BOOL bHasData = FALSE;
				BYTE iData = 0;
				BYTE iReadLen = 0;
				
				BOOL bTemp = FALSE;
				if (g_CECMgr.HasReadData(&bTemp))
					bHasData = bTemp;

				if (bHasData)
				{
					m_pPollParent->SendMessage(CEC_MESSAGE_DATA_START);
					BYTE CECReadData[20];
					int iNumReadData = 20;
					ZeroMemory(CECReadData,sizeof(CECReadData));
					if (g_CECMgr.ReadData(CECReadData,&iNumReadData))
					{
						for (int i = 0; i < iNumReadData; i ++)
							m_pPollParent->SendMessage(CEC_MESSAGE_HAS_DATA,CECReadData[i],NULL);
					}
					m_pPollParent->SendMessage(CEC_MESSAGE_DATA_END);
				}

				if (WaitForSingleObject(m_pEventThreadEnd->m_sem, 0) == WAIT_OBJECT_0) // if end thread event was signalled
				{
					SAFE_DELETE(pEvent);
					return -1;		// we exit this thread
				}
				DWORD dwSleepTime, dwElapsedTime = GetTickCount() - dwStartTime;
				dwSleepTime = (dwElapsedTime < m_iPollInterval) ? m_iPollInterval - dwElapsedTime : 0;
				if (WaitForSingleObject(m_pEventThreadEnd->m_sem, dwSleepTime) == WAIT_OBJECT_0) // if end thread event was signalled
				{
					SAFE_DELETE(pEvent);
					return -1;		// we exit this thread
				}

			} while(TRUE);
		}
		break;
	}

	SAFE_DELETE(pEvent);

	return 0;
}

void CMX_CECUtilDlg::OnBnClickedButtonLogClear()
{
	m_LogListBoxCtrl.ResetContent();
}
