

#ifndef CONFIG_H
#define CONFIG_H

#include <limits.h>


#define HAVE_UNISTD_H 0
#define HAVE_IO_H 1

#define BEGIN_NAMESPACE(n)			namespace n {
#define END_NAMESPACE(n)			}	// namespace n



#if HAVE_UNISTD_H
#define RD_BNRY_FLAGS O_RDONLY
#elif HAVE_IO_H
#define RD_BNRY_FLAGS O_RDONLY | O_BINARY
#endif

/* Endian Issues */
#ifdef LINUX
#include <endian.h>
#endif

#ifdef WIN32
#define SAFEDELETE(X) if(X){delete(X); X=0;}
#define SAFEFREE(X)   if(X){free(X); X=0;}
typedef  int BOOL;
#define TRUE  1
#define FALSE 0
#define __LITTLE_ENDIAN 1234
#define __BIG_ENDIAN    4321
#define __PDP_ENDIAN    3412
#define __BYTE_ORDER    __LITTLE_ENDIAN
#define usleep(x) Sleep(x/1000)
#define strcasecmp(a,b) stricmp(a,b)
#endif

/* define our datatypes */
// real number

typedef double real;

#if UCHAR_MAX == 0xff

typedef unsigned char	UINT_8;
typedef signed char		INT_8;

#else
#error This machine has no 8-bit type
#endif

#if UINT_MAX == 0xffff

typedef unsigned int	UINT_16;
typedef int				INT_16;

#elif USHRT_MAX == 0xffff

typedef unsigned short	UINT_16;
typedef short			INT_16;

#else
#error This machine has no 16-bit type
#endif


#if UINT_MAX == 0xfffffffful

typedef unsigned int	UINT_32;
typedef int				INT_32;

#elif ULONG_MAX == 0xfffffffful

typedef unsigned long	UINT_32;
typedef long			INT_32;

#elif USHRT_MAX == 0xfffffffful

typedef unsigned short	UINT_32;
typedef short			INT_32;

#else
#error This machine has no 32-bit type
#endif


// What character marks the end of a directory entry? For DOS and
// Windows, it is "\"; in UNIX it is "/".
#if defined(WIN32) || defined(OS2) || defined(__DOS__)
#define DIR_MARKER '\\'
#define DIR_MARKER_STR "\\"
#else
#define DIR_MARKER '/'
#define DIR_MARKER_STR "/"
#endif /* WIN32 */

// What character(s) marks the end of a line in a text file? 
// For DOS and Windows, it is "\r\n"; in UNIX it is "\r".
#if defined(WIN32) || defined(OS2) || defined(__DOS__)
#define LINE_END_MARKER_STR "\r\n"
#else
#define LINE_END_MARKER_STR "\n"
#endif /* WIN32 */

#ifndef NULL
#ifdef  __cplusplus
#define NULL    0
#else
#define NULL    ((void *)0)
#endif
#endif /* NULL */

#endif /* CONFIG_H */
