// EventThread.h: interface for the CEventThread class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EVENTTHREAD_H__A2900D4E_A503_4260_8072_6E03ED53C004__INCLUDED_)
#define AFX_EVENTTHREAD_H__A2900D4E_A503_4260_8072_6E03ED53C004__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "thread.h"
#include "MsgEvent.h"
#include "semaphore.h"
#include "queue.h"

class CEventThread
{
public:
	CEventThread();
	virtual ~CEventThread();
	INT_32 AcceptEvent(CMsgEvent *pEvent);

	void StartEventThread();
	void StopEventThread();

	// Overridable
	virtual INT_32 ServiceEvent(CMsgEvent *pEvent);
	virtual void InitEventThread();
	virtual void DeinitEventThread();

private:
	static void EventThreadFunc(void* pArg);

protected:
	Thread*				m_pEventThread;
	Semaphore*			m_pEventThreadSemaphore;
	Semaphore*			m_pEventThreadEnd;
	Queue<CMsgEvent*>*	m_pEventThreadQueue;
};

#endif // !defined(AFX_EVENTTHREAD_H__A2900D4E_A503_4260_8072_6E03ED53C004__INCLUDED_)
