#include "stdafx.h"
#include "Mutex.h"

/******************************************************************************
 * Constructor for CMutex.
 *   Input: 
 *   Output:
 *   Effect:
 ******************************************************************************/
CMutex::CMutex(bool bInitialOwner)
{
	m_hMutexObj = CreateMutex(NULL, bInitialOwner, NULL);
}	

/******************************************************************************
 * Destructor for CMutex.
 *   Input: 
 *   Output:
 *   Effect:
 ******************************************************************************/
CMutex::~CMutex()
{
	CloseHandle(m_hMutexObj);
}

/******************************************************************************
 * This function waits to acquire the mutex object until it releases it later.
 *   Input: dwTimeout -- time to wait before it quits in acquiring the 
 *                       mutex object <INFINITE>.
 *   Output:
 *   Effect:
 ******************************************************************************/
bool CMutex::Acquire(DWORD dwTimeout)
{
	bool result = false;
	switch(WaitForSingleObject(m_hMutexObj, dwTimeout))
	{
		case WAIT_ABANDONED:
		case WAIT_OBJECT_0:
		{
			result = true;
			break;
		}
		case WAIT_TIMEOUT:
		case WAIT_FAILED:
		{
			result = false;
			break;
		}
	}

	return result;
}

