
#ifndef THREAD_H
#define THREAD_H

typedef void (*thread_function)(void * arg);

typedef enum Priority{
	Idle			= -15,
	Low				= -2,
	BelowNormal		= -1,
	Normal			= 0,
	AboveNormal		= 1,
	High			= 2,
	Critical		= 15,

}Priority;

class Thread {

public:
    virtual ~Thread(){}


	virtual bool Create(thread_function function, void* arg) = 0;
	virtual void Destroy() = 0;
	virtual void Suspend() = 0;
	virtual void Resume() = 0;
	virtual void Join() = 0;

	virtual Priority GetPriority() const = 0;
	virtual Priority SetPriority(Priority priority) = 0;

    static Thread* CreateThread();
};



#endif /* THREAD_H */
