
#ifndef _WIN32_THREAD_H
#define _WIN32_THREAD_H

#include <windows.h>
#include "thread.h"
#include "config.h"


class win32Thread : public Thread {

public:
	win32Thread();
	~win32Thread();


	virtual bool Create(thread_function function, void* arg);
	virtual void Destroy();
	virtual void Suspend();
	virtual void Resume();
	virtual void Join();

	virtual Priority GetPriority() const;
	virtual Priority SetPriority(Priority priority);

    static unsigned long __stdcall internalThreadFunction(void* arg);

    UINT_32 InternalThreadFunction(); 

private:
	Priority	    m_priority;
	HANDLE		    m_threadHandle;	
	unsigned long	    m_threadId;

    thread_function m_function;
    void*           m_arg;


};

#endif /* _WIN32_THREAD_H */
