// WaitDiscoverDevDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MX_CECUtil.h"
#include "MX_CECUtilDlg.h"
#include "WaitDiscoverDevDlg.h"


// CWaitDiscoverDevDlg dialog

IMPLEMENT_DYNAMIC(CWaitDiscoverDevDlg, CDialog)

CWaitDiscoverDevDlg::CWaitDiscoverDevDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWaitDiscoverDevDlg::IDD, pParent)
{

}

CWaitDiscoverDevDlg::~CWaitDiscoverDevDlg()
{
}

void CWaitDiscoverDevDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PROGRESS_DISCOVER_DEV, m_DiscoverDevPrgsCtrl);
}


BEGIN_MESSAGE_MAP(CWaitDiscoverDevDlg, CDialog)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_CANCEL, &CWaitDiscoverDevDlg::OnBnClickedButtonCancel)
END_MESSAGE_MAP()


BOOL CWaitDiscoverDevDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetTimer(1000,500,NULL);
	m_DiscoverDevPrgsCtrl.SetRange(0,NUM_LOGICAL_DEV-1);

	return TRUE;  // return TRUE  unless you set the focus to a control
}


// CWaitDiscoverDevDlg message handlers

void CWaitDiscoverDevDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == 1000)
	{
		CMX_CECUtilDlg* pParent = (CMX_CECUtilDlg*)GetParent();
		int iCurrPrgs = pParent->GetDiscoverDevPrgs();
		m_DiscoverDevPrgsCtrl.SetPos(iCurrPrgs);
		if (iCurrPrgs >= NUM_LOGICAL_DEV)
			OnBnClickedButtonCancel();
	}

	CDialog::OnTimer(nIDEvent);
}

void CWaitDiscoverDevDlg::OnCancel()
{
	if (!m_bExit)
		return;
	CDialog::OnCancel();
}

void CWaitDiscoverDevDlg::OnOK()
{
	if (!m_bExit)
		return;
	CDialog::OnOK();
}

void CWaitDiscoverDevDlg::OnBnClickedButtonCancel()
{
	m_bExit = TRUE;
	OnOK();
}
